# STM32L496G-DISCO Discovery board

## Overview

The STM32L496G-DISCO Discovery kit is a complete demonstration and development platform for STMicroelectronics Arm® Cortex®-M4 core-based STM32L496AG microcontroller, with 1 Mbyte of flash memory and 320 Kbytes of SRAM.

The full range of hardware features available on the board helps users to enhance their application development by an evaluation of all the peripherals (such as USB OTG FS, microSD™ card, 8-bit camera, 8-Mbit PSRAM, RGB interface LCD with capacitive touch panel, and others). ARDUINO® Uno V3, Pmod™ and STMod+ connectors provide easy connection to extension shields or daughterboards for specific applications.

ST-LINK/V2-1 is integrated into the board, as the embedded in-circuit debugger and programmer for the STM32 MCU and USB Virtual COM port bridge.

## Getting started

- [User manual](https://www.st.com/resource/en/user_manual/um2160-discovery-kit-with-stm32l496ag-mcu-stmicroelectronics.pdf)

### ST-LINK driver installation and firmware upgrade (on Microsoft Windows)

1. Download the latest [ST-LINK driver](https://www.st.com/en/development-tools/stsw-link009.html).
2. Extract the archive and run `dpinst_amd64.exe`. Follow the displayed instructions.
3. Download the latest [ST-LINK firmware upgrade](https://www.st.com/en/development-tools/stsw-link007.html).
4. Extract the archive and run the `ST-LinkUpgrade.exe` program.
5. Connect the board to your PC using a USB cable and wait until the USB enumeration is completed.
6. In the **ST-Link Upgrade** program, press the **Device Connect** button.
7. When the ST-LINK driver is correctly installed, the current ST-LINK version is displayed.
8. Press the **Yes >>>>** button to start the firmware upgrade process.

## Technical reference

- [STM32L496 microcontroller](https://www.st.com/en/microcontrollers-microprocessors/stm32l496ag.html)
- [STM32L496G-DISCO board](https://www.st.com/en/evaluation-tools/32l496gdiscovery.html)
- [User manual](https://www.st.com/resource/en/user_manual/um2160-discovery-kit-with-stm32l496ag-mcu-stmicroelectronics.pdf)
- [Data brief](https://www.st.com/resource/en/data_brief/32l496gdiscovery.pdf)
- [Schematic](https://www.st.com/resource/en/schematic_pack/mb1261-l496g-b01-schematic.pdf)
